package ChangeSynergy::mrcActions;

use strict;
use warnings;
use vars qw(); #this is the globals section
use ChangeSynergy::util; #The xmlDecode method exists in this class.
use XML::Lite; #We need this to actually do the XML parsing for us.
use ChangeSynergy::mrcActionsObjRc;

sub new()
{
	shift;

	# Initialize data as an empty hash.
	my $self    = {};

	# Bless reference into class;
	bless $self;	

	# Get the xml file and create the XML parsing object.
	my $xmlFile = shift;

	if(defined($xmlFile))
	{
		my $xml      = new XML::Lite($xmlFile);
		$self->{xml} = $xml;
	}
	else
	{
		$self->{xml} = undef;
	}

	$self->{objRcs} = undef;

	if(defined($self->{xml}))
	{
		&parseXml($self);
	}


	return $self;
}

sub getObjectRc()
{
	my $self = shift;
	my $doorsID = shift;

	return $self->{objRcs}{$doorsID};
}

sub getAllObjectRcs()
{
	my $self = shift;
	return $self->{objRcs};
}

#
# Private Methods
#
sub parseXml
{
	my $self = shift;
	my $child;
	my @objRcData = $self->{xml}->elements_by_name("OBJ_RC");
	my %tmpHash = ();
	foreach $child (@objRcData)
	{
		my $objRc = new ChangeSynergy::mrcActionsObjRc($child->get_content());
		my $doorsID = $objRc->get_doorsID();
		%tmpHash->{$doorsID} = $objRc;
	}
	$self->{objRcs} = \%tmpHash;
}

1;
