/*
 * ECP_MultiSelect.js
 *
 * ECP_MultiSelect is a JavaScript class with a set of functions for the
 * base.ECP_MULTISELECT widget.
 */

 
function ECP_MultiSelect()
{
}

/*
 * Settings
 */

ECP_MultiSelect.getDelimiter = function()
{
	return ';';
}

ECP_MultiSelect.getListboxDefault = function()
{
	return 'Any';
}

/*
 * Change functions
 */

ECP_MultiSelect.setValue = function(attributeId, value, isModified)
{
	var ctrl = document.getElementById(attributeId);
	var isReadOnly = ctrl.getAttribute("isReadOnly");

	if (CtrlUtils.equalsTrue(isReadOnly))
	{
		return;
	}

	ctrl.setAttribute("isModified", isModified);
	ECP_MultiSelect.populateListbox(attributeId, value);
};

/*
 * Helper functions
 */

ECP_MultiSelect.addOnClick = function(attributeId, attributeIdLookup)
{
	if (IsFormLoadingSilent())
	{
		return;
	}

	var ctrl = document.getElementById(attributeId);
	var ctrlLookup = document.getElementById(attributeIdLookup);
	
	var j = ctrlLookup.length;
	var i = 0;
	var elementsToAdd = new Array();
	var alreadyExists = false;
	
	for (i = 0; i < j; i++)
	{
		if (ctrlLookup.options[ i ].selected)
		{
			alreadyExists = false;
			
			for (m = 0; m < ctrl.length; m++)
			{
				if (ctrl.options[m].text == ctrlLookup.options[i].text)
				{	
					alreadyExists = true;
					break;					
				}				
			}
			
			if (!alreadyExists)
			{
				elementsToAdd.push(ctrlLookup.options[i].text);				
			}
		}
	}
	
	if (elementsToAdd.length != 0)
	{
		ctrlLookup.selectedIndex = -1;
		
		for (i = 0; i < elementsToAdd.length; i++)
		{
			ctrl.options[ctrl.length]  = new Option(elementsToAdd[i], ctrl.length);
		}
	}

	ECP_MultiSelect.onChange(ctrl);
}

ECP_MultiSelect.onChange = function(ctrl)
{
	var value = '';
	for (var i=0, j=ctrl.length; i < j; i++)
	{
		if (value == '')
		{
			value += ctrl.options[i].text;
		}
		else
		{
			value += ECP_MultiSelect.getDelimiter() + ctrl.options[i].text;
		}
	}

	ctrl.setAttribute('currentValue', value);
	CtrlUtils._markAsChanged(ctrl);
}

ECP_MultiSelect.populateListbox = function(attributeId, value)
{
	var ctrl = document.getElementById(attributeId);

	ctrl.length = 0;
	if (value == null || value == '')
	{
		return;
	}

	var list = value.split(ECP_MultiSelect.getDelimiter());
	if (list == null)
	{
		return;
	}

	for (var i=0, count=list.length; i < count; i++)
	{
		if (list[i] != "")
		{
			ctrl.options[ctrl.length] = new Option(list[i],i);
		}
	}
};

ECP_MultiSelect.removeDefault = function(attributeId)
{
	var ctrl = document.getElementById(attributeId);

	var len = ctrl.length;
	var i = 0;
	while (i < len)
	{
		if (ctrl.options[i].text == ECP_MultiSelect.getListboxDefault())
		{  
			ctrl.options[i] = null;
			break;
		}
		i++;
	}
}

ECP_MultiSelect.removeOnClick = function (attributeId, attributeIdLookup)
{
	if (IsFormLoadingSilent())
	{
		return;
	}

	var ctrl = document.getElementById(attributeId);
	var ctrlLookup = document.getElementById(attributeIdLookup);

	var i = (ctrl.length - 1);
	var j = 0;
	for (j=0; i >= j; i--)
	{
		if (ctrl.options[i].selected)
		{
			ctrl.options[i] = null;
		}
	}

	ECP_MultiSelect.onChange(ctrl);
}
