<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<!-- admin_framework\manage_friends.jsp -->

<html>
<head>
	<title><change:resource key="friendsTab"/></title>

	<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css">
	<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/tundra/tundra.css">

	<style type="text/css">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- PARAM NAME=styles/note.css -->
			<!-- PARAM NAME=styles/tabs_wrappable.css -->
			<!-- PARAM NAME=styles/visual_table.css -->
			<!-- /WSLET -->
		</change:wsletExpander>

		table.visual-table {
			margin-left: 0;
			margin-right: 0;
		}

		.wrapper {
				/* center the page */
				width: 56em;
				padding: 0;
				margin: 0 auto;
				text-align: left;
		}


		.dijitDialogCloseIcon {
			display: none;
		}

		table input {
			width: 40em;
		}

		hr {
			margin-top: 14px;
			margin-bottom: 7px;
		}

		.title-column {
			text-align: right;
		}

		.error-icon {
			top: 2px;
			margin-right: 2px;
		}

		.note  {
			width: 100%;
		}

		/* normalize space since IE defaults to a lot */
		 h1, p {
			margin: 1em 0;
		}
	</style>
</head>

<body class="tundra">

	<div class="wrapper">

		<c:set var="outgoing" value="${true}"/>
		<%@ include file="oslc_tabs.jspf" %>

		<h1><change:resource key="friendsLabel"/></h1>

		<p class="help-text">
			<change:resource key="friendsHelp"/>
		</p>
		
		<div style="">
			<a href="#" onclick="onShowAddFriend(event)">
				<change:resource key="addFriend"/>
			</a>
		</div>
		
		<table class="visual-table" style="width: 100%">
			<col width="1"><col width="9999"><col width="1">
			<thead>
			<tr>
				<th>
					<change:resource key="consumerDisplayNameHeader"/>
				</th>
				<th>
					<change:resource key="rootServicesUrlTitle"/>
				</th>
				<th>
					&nbsp;
					<!-- empty header for "Edit | Remove " row -->
				</th>
			</tr>
			</thead>

			<!--  if length of roles is 0 then show this, else hide it. -->
			<c:if test="${empty friends}">
				<tbody class="informational">
				<tr>
					<td colspan="4">
						<change:resource key='noFriends'/>
					</td>
				</tr>
				</tbody>
			</c:if>

			<c:if test="${not empty friends}">
			<tbody>
				<c:forEach items="${friends}" var="friend" varStatus="status">
					<tr rowId="${status.index}" <c:if test="${status.index % 2 == 1}">class="odd-row"</c:if>>
						<td>
								${friend.displayName}
						</td>
						<td>
								${friend.rootServices}
						</td>
						<td class="row-widgets">
							<a href="#" onclick="showEditFriend('${friend.rootServices}'); return false;"><change:resource key='lbl00614'/></a>
							|
							<a href="#" onclick="removeFriend('${friend.rootServices}'); return false;"><change:resource key='lbl01155'/></a>
						</td>
					</tr>
				</c:forEach>
				</tbody>
			</c:if>

		</table>
		
		<div class="note" id="note" style="display: none;">
			<p>
				<img class="error-icon" alt="<change:resource key='altTextWarning'/>" src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif">
				<span id="note-message"></span>
			</p>
		</div>

		<form method="GET" name="changeFormLoader" action="<change:urlCreator webResource='PTWEB'/>" class="hiddenForm">
				<input name="ACTION_FLAG" type="hidden" value="admin_form">
				<input name="TEMPLATE_FLAG" type="hidden" value="Admin">
				<input name="role" type="hidden" value="<c:out value="${user.role}"/>">
				<input name="token" type="hidden" value="<c:out value="${user.token}"/>">
				<input name="formName" type="hidden" value="adminServerTab">
		</form>

		<form name="messageAction" method="GET" action="<change:urlCreator webResource='BASEURL'/>/manage_friends.do">
			<input name="token" type="hidden" value="${user.token}">
		</form>

		<form name="statusAction" target="pt_status" method="GET" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do">
			<input name="token" type="hidden" value="${user.token}">
			<input name="formName" type="hidden" value="statusLineMessage">
			<input name="isErrorMessage" type="hidden" value="false">
			<input name="message" type="hidden">
		</form>
		
	</div>

	<div dojoType="dijit.Dialog" class="dojoDialog" id="friends-dialog" duration="1" style="display: none; width: 60em;"
		title="Friend">
		<form name="dialogForm" id="dialog-form">
			<div style="margin: 5px">
				<table width="100%">
					<tr>
						<td class="title-column">
							<label for="consumer-display-name" class="label_decoration">
								<change:resource key="consumerDisplayNameLabel"/>
							</label>
						</td>
						<td>
							<input type="text" name="displayName" id="consumer-display-name" autocomplete="off">
						</td>
					</tr>
					<tr>
						<td class="title-column">
							<label for="root-services" class="label_decoration">
								<change:resource key="rootServicesUrlLabel"/>
							</label>
						</td>
						<td>
							<input type="text" name="rootServices" id="root-services" autocomplete="off">
						</td>
					</tr>
					<tr>
						<td class="title-column">
							<label for="consumer-key" class="label_decoration">
								<change:resource key="consumerKeyLabel"/>
							</label>
						</td>
						<td>
							<input type="text" name="consumerKey" id="consumer-key" autocomplete="off">
						</td>
					</tr> 
					<tr>
						<td class="title-column">
							<label for="consumer-secret" class="label_decoration">
								<change:resource key="consumerSecretLabel"/>
							</label>
						</td>
						<td>
							<input type="password" name="consumerSecret" id="consumer-secret" autocomplete="off">
						</td>
					</tr>
					<tr>
						<td class="title-column">
							<label for="confirm-consumer-secret" class="label_decoration">
								<change:resource key="confirmConsumerSecretLabel"/>
							</label>
						</td>
						<td>
							<input type="password" id="confirm-consumer-secret" autocomplete="off">
						</td>
					</tr>
				</table>
				
				<hr>

				<div style="text-align: center;">
					<input type="submit" id="save" class="button" value="<change:resource key="lbl00592"/>">
				
					<button type="button" id="cancel-find" onClick="hideDialog()" class="button"> 
						<change:resource key="lbl00249"/>
					</button>
				</div>
			</div>
		</form>

		<div id="dialog-note" class="note" style="display: none;">
			<p>
				<img class="error-icon" alt="<change:resource key='altTextWarning'/>" src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif">
				<span id="dialog-note-message"></span>
			</p>
		</div>

	</div>

	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/ManageOAuthConsumersAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>

	<script type="text/javascript">
		dojo.require("dijit.Dialog");
		
		var $ = dojo.byId;
		var $$ = dojo.query;

		var _friends = ${jsonFriends};

		function hideDialog()
		{
			dijit.byId("friends-dialog").hide();
		}

		function onShowAddFriend(e)
		{
			dojo.stopEvent(e || window.event);
			showAddFriend();
		}
		
		var _isEdit;

		function showAddFriend()
		{
			var d = dijit.byId("friends-dialog");
			clearDialog();
			$('save').disabled = false;
			_isEdit = false;
			d.attr('title', '<change:resource key="addFriend"/>');
			d.show();
		}
		
		function showEditFriend(key)
		{ 
			var friend = _friends[key];
			if (!friend) return;
			
			clearDialog();

			var rootServices = $('root-services');
			rootServices.value = friend['rootServices'];
			rootServices.disabled = true;
			$('consumer-display-name').value = friend['name'];
			$('consumer-key').value = friend['consumerKey'];
			
			var d = dijit.byId("friends-dialog");
			$('save').disabled = false;
			_isEdit = true;
			d.attr('title', '<change:resource key="editFriend"/>');
			d.show();
		}
		
		function refreshWithStatusMessage(message)
		{
			document.statusAction.message.value = message;
			document.statusAction.submit();
			location.reload(true);
		}
		
		function showDialogError(message)
		{
			dojo.empty($('dialog-note-message'));
			$('dialog-note-message').appendChild(document.createTextNode(message));
			$('dialog-note').style.display = '';
			$('save').disabled = false;
		}

		function showError(message)
		{
			dojo.empty($('note-message'));
			$('note-message').appendChild(document.createTextNode(message));
			$('note').style.display = '';
		}

		function onSave(e)
		{
			dojo.stopEvent(e);
			
			var ajaxFunction;
			
			if (_isEdit)
			{
				if (!validInput(true)) return;
				ajaxFunction = ManageOAuthConsumersAjax.editFriend;
			}
			else
			{
				if (!validInput(false)) return;
				ajaxFunction = ManageOAuthConsumersAjax.addFriend;
			}

			$('save').disabled = true;

			var friend = dojo.formToObject('dialog-form')
			
			<%-- Get this even if disabled --%>
			friend.rootServices = document.dialogForm.rootServices.value;

			ajaxFunction("${user.token}", friend, {
				callback: refreshWithStatusMessage,
				errorHandler: showDialogError
			});
		}


		function removeFriend(key)
		{
			if (!confirm('<change:resource key="removeFriend" />'))
			{
				return;
			}

			ManageOAuthConsumersAjax.removeFriend("${user.token}", key, {
				callback: refreshWithStatusMessage,
				errorHandler: showError
			});
		}

		function clearDialog()
		{
			$("consumer-display-name").value = "";
			$("root-services").value = "";
			$("root-services").disabled = false;
			$("consumer-key").value = "";
			$("consumer-secret").value = "";
			$("confirm-consumer-secret").value = "";
			$("dialog-note").style.display = "none";
		}

		function validInput(isEdit)
		{
			var name = document.dialogForm.displayName.value;
			var rootServices = document.dialogForm.rootServices.value;
			var key = document.dialogForm.consumerKey.value
			var secret = document.dialogForm.consumerSecret.value;
			var confirmSecret = $('confirm-consumer-secret').value;
			
			if (!name || !rootServices || !key)
			{
				showDialogError('<change:resource key="reqFieldsText"/>');
				return false;
			}
			else if (!isEdit)
			{
				if (!secret || !confirmSecret)
				{
					showDialogError('<change:resource key="reqFieldsText"/>');
					return false;
				}
			}

			if (secret != confirmSecret)
			{
				showDialogError('<change:resource key="consumerSecretsNoMatch"/>');
				return false;
			}
			
			return true;
		}

		dojo.addOnLoad(function() {
			dojo.query('#friends-dialog input').onkeydown(function() {
				var message = $('dialog-note');
				message.style.display = 'none';
			});

			dojo.connect($('dialog-form'), 'onsubmit', onSave);

			<%@ include file="oslc_tabs_onload.jspf" %>		
		});

	</script>

</body>
</html>
