<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<!-- manage_oauth.jsp -->

<html>
<head>
	<title><change:resource key="oauthConsumersTab"/></title>
	
	<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css">
	<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/tundra/tundra.css">
	 
	<style type="text/css">

		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- PARAM NAME=styles/note.css -->
			<!-- PARAM NAME=styles/tabs_wrappable.css -->
			<!-- PARAM NAME=styles/visual_table.css -->
			<!-- /WSLET -->
		</change:wsletExpander>


		table.visual-table {
			margin-left: 0;
			margin-right: 0;
		}

		.wrapper {
				/* center the page */
				width: 56em;
				padding: 0;
				margin: 0 auto;
				text-align: left;
		}

		.dijitDialogCloseIcon {
			display: none;
		}

		table input {
			width: 30em;
		}

		hr {
			margin-top: 14px;
			margin-bottom: 7px;
		}

		.title-column {
			text-align: right;
		}

		.error-icon {
			top: 2px;
			margin-right: 2px;
		}

		
		/* normalize space since IE defaults to too much */
		 h1, p {
			margin: 1.5em 0 1em 0;
		}
		
		p.code-block, .code-block {
			margin: 5px;
			font-family: monospace;
			border: dotted gray 1px;
			background-color: #FFFCD7;
		}
		
		.help-text a {
			color: #636363;
		}


	</style>

</head>

<body class="tundra">

	<c:set value="${fn:length(consumers)}" var="numberOfConsumers"/>
	<%@ include file="manage_oauth_consumer_dialog.jspf" %>

	<div class="wrapper">

		<c:set var="incoming" value="${true}"/>
		<%@ include file="oslc_tabs.jspf" %>
			

		<h1><change:resource key="approvedOauthConsumers"/></h1>

		<div class="help-text">
			<change:resource key="oAuthConsumerKeysHelpHtml"/>
		</div>
		
		<div id="show-root-service" class="help-text">
			<change:resource key="rootServicesHelpLinkHtml"/>
		</div>
		
 		<div id="root-services" class="note" style="display: none;">
			<p>
				<change:resource key="rootServicesForMostIntegrations"/>
			</p>

			<p class="code-block">
				<c:out value="${rootServicesUrl}"/>
			</p>

			<p>
				<change:resource key="rootServicesForFlatIntegrations"/>
			</p>
			
			<p class="code-block">
				<c:out value="${flatRootServicesUrl}"/>	
			</p>			

		</div>

		<div style="margin-top: 1.5em;">
			<a href="#" onclick="dojo.stopEvent(event); registerOrManageConsumer('new', '')">
				<change:resource key="addConsumer"/>
			</a>
		</div>
		
		<table class="visual-table" width="100%">
		<thead>
		<tr>
			<th>
				<change:resource key="lbl01131"/>
			</th>
			<th style="width: 3000px">
				<change:resource key="consumerKeyHeader"/>
			</th>
			<th>
				&nbsp;
				<!-- empty header for "Manage | Unregister" row -->
			</th>
		</tr>
		</thead>

		<!--  if length of roles is 0 then show this, else hide it. -->
		<tbody class="informational" <c:if test="${numberOfConsumers != 0}"> style="display: none;"</c:if>>
		<tr>
			<td colspan="3" width="100%">
				<change:resource key='noConsumersRegistered'/>
			</td>
		</tr>
		</tbody>
		<tbody>
		<c:forEach items="${consumers}" var="consumer" varStatus="status">
			<tr rowId="${status.index}" <c:if test="${status.index % 2 == 1}">class="odd-row"</c:if>>
				<td>
						${consumer.displayName}
				</td>
				<td>
						${consumer.consumerKey}
				</td>
				<td class="row-widgets">
					<a href="#" onclick="registerOrManageConsumer('manage', '${consumer.consumerKey}')"><change:resource key='lbl00614'/></a>
					|
					<a href="#" onclick="unregisterConsumer('${consumer.consumerKey}')"><change:resource key='lbl01155'/></a>
				</td>
			</tr>
		</c:forEach>
		</tbody>
		</table>

		<c:if test="${not empty provisionalConsumers}">

			<h1 style="margin-top: 3em;"><change:resource key="provisionalKeys"/></h1>

			<div class="help-text">
				<p>
					<change:resource key="oAuthProvisionalKeysHelpHtml"/>
				</p>
			</div>
		
			<table class="visual-table" style="width: 100%">
				<thead>
				<tr>
					<th>
						<change:resource key="consumerDisplayNameHeader"/>
					</th>
					<th style="width: 3000px">
						<change:resource key="consumerKeyHeader"/>
					</th>
					<th>
						&nbsp;
						<!-- empty header for "Edit | Remove" row -->
					</th>
				</tr>
				</thead>

				<tbody >
				<c:forEach items="${provisionalConsumers}" var="provisional" varStatus="status">
					<tr rowId="${status.index}" <c:if test="${status.index % 2 == 1}">class="odd-row"</c:if>>
						<td>
								${provisional.displayName}
						</td>
						<td>
								${provisional.consumerKey}
						</td>
						<td class="row-widgets">
							<a href="#" onclick="approve('${provisional.consumerKey}')"><change:resource key="approve"/></a>
							|
							<a href="#" onclick="reject('${provisional.consumerKey}')"><change:resource key="reject"/></a>
						</td>
					</tr>
				</c:forEach>
				</tbody>
			</table>
		</c:if>

		<div class="note" id="note" style="display: none;">
			<p>
				<img class="error-icon" alt="<change:resource key='altTextWarning'/>" src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif">
				<span id="note-message"></span>
			</p>
		</div>


		<form method="GET" name="changeFormLoader" action="<change:urlCreator webResource='PTWEB'/>" class="hiddenForm">
				<input name="ACTION_FLAG" type="hidden" value="admin_form">
				<input name="TEMPLATE_FLAG" type="hidden" value="Admin">
				<input name="role" type="hidden" value="<c:out value="${user.role}"/>">
				<input name="token" type="hidden" value="<c:out value="${user.token}"/>">
				<input name="formName" type="hidden" value="adminServerTab">
		</form>

		<form name="statusAction" target="pt_status" method="GET" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do">
			<input name="token" type="hidden" value="${user.token}">
			<input name="formName" type="hidden" value="statusLineMessage">
			<input name="isErrorMessage" type="hidden">
			<input name="message" type="hidden">
		</form>

	</div>

<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/ManageOAuthConsumersAjax.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>

<script type="text/javascript">
	dojo.require("dijit.Dialog");
	
	var $ = dojo.byId;
	var $$ = dojo.query;

	var toEdit = false;

	function hasModifications()
	{
		return false;
	}

	function showDialog(title)
	{
		var dlg = dijit.byId("oauth-consumers-dialog");
		title && dlg.attr('title', title);
		dlg.show();
	}

	function hideDialog()
	{
		var dlg = dijit.byId("oauth-consumers-dialog");
		dlg.hide();
	}
	
	function showError(message)
	{
		dojo.empty($('note-message'));
		$('note-message').appendChild(document.createTextNode(message));
		$('note').style.display = '';
	}

	function registerOrManageConsumer(val, key)
	{
		if (val == "new")
		{
			clearDialog();
			registerConsumer();
			toEdit = false;
		}
		else if (val == "manage")
		{
			$("msg").style.display = "none";
			$("consumer-secret").value = "";
			manageConsumer(key);
			toEdit = true;
		}
	}

	function approve(key)
	{
		ManageOAuthConsumersAjax.approveProvisionalConsumer("${user.token}", key, refreshOnCallback);
	}

	function reject(key)
	{
		if (confirm('<change:resource key="rejectConsumerKeyPrompt"/>'))
		{
			ManageOAuthConsumersAjax.rejectProvisionalConsumer("${user.token}", key, refreshOnCallback);
		}
	}

	function registerConsumer()
	{
		showDialog('<change:resource key="addConsumer"/>');
	}

	function performAction()
	{
		if (!validInput(toEdit))
		{
			return;
		}
		
		$('save').disabled = true;

		if (toEdit)
		{
			updateAConsumer();
		}
		else
		{
			registerAConsumer();
		}
	}

	function registerAConsumer()
	{
		var consumer = createConsumerObject();

		ManageOAuthConsumersAjax.addConsumer("${user.token}", consumer, refreshOnCallback);
	}

	function updateAConsumer()
	{
		var consumer = createConsumerObject();
		ManageOAuthConsumersAjax.editConsumer("${user.token}", consumer, refreshOnCallback);
	}

	function refreshList()
	{
		document.location.reload(true);
	}

	function refreshOnCallback(result)
	{
		if (result.errorMessage)
		{
			alertUser(result.message);
		}
		else
		{
			document.statusAction.isErrorMessage.value = result.errorMessage;
			document.statusAction.message.value = result.message;
			document.statusAction.submit();
			refreshList();
		}
	}

	function createConsumerObject()
	{
		var consumer = new Object();
		consumer.displayName = $("consumer-display-name").value;
		consumer.consumerKey = $("consumer-key").value;
		consumer.consumerSecret = $("consumer-secret").value;

		return consumer;
	}

	function unregisterConsumer(key)
	{
		if (!confirm('<change:resource key="confirmRemoveConsumerKey" />'))
		{
			return;
		}

		ManageOAuthConsumersAjax.removeConsumer("${user.token}", key, refreshOnCallback);
	}

	function manageConsumer(key)
	{
		var allConsumers = getAllConsumersAsObjectArray();
		var ckey = "";
		var name = "";

		for (var i = 0; i < allConsumers.length; i++)
		{
			var o = allConsumers[i];
			if (key == o.consumerKey)
			{
				ckey = o.consumerKey;
				name = o.displayName;
				break;
			}
		}

		showManageDialog(ckey, name);
	}

	function showManageDialog(key, name)
	{
		$("consumer-display-name").value = name;
		$("consumer-key").value = key;
		$("consumer-key").disabled = true;

		showDialog('<change:resource key="editConsumer"/>');
	}

	function getAllConsumersAsObjectArray()
	{
		var consumersAsArray = new Array();
		<c:forEach items="${consumers}" var="consumer" varStatus="status">
		var consumer = new Object();
		consumer.displayName = '<c:out value="${consumer.displayName}"/>';
		consumer.consumerKey = '<c:out value="${consumer.consumerKey}"/>';
		consumersAsArray.push(consumer);
		</c:forEach> 

		return consumersAsArray;
	}

	function clearDialog()
	{
		$("consumer-display-name").value = "";
		$("consumer-key").value = "";
		$("consumer-secret").value = "";
		$("confirm-consumer-secret").value = "";
		$("consumer-key").disabled = false;
		$("msg").style.display = "none";
	}

	function validInput(edit)
	{
		var cdn = $("consumer-display-name").value;
		var ck = $("consumer-key").value;
		var csc = $("consumer-secret").value;
		var confirmSecret = $("confirm-consumer-secret").value;

		if (edit)
		{
			if(cdn == "" || ck == "" )
			{
				alertUser('<change:resource key="reqFieldsText"/>');
				return false;
			}
		}
		else if (cdn == "" || ck == "" || csc == "")
		{
			alertUser('<change:resource key="reqFieldsText"/>');
			return false;
		}

		if (csc != confirmSecret)
		{
			alertUser('<change:resource key="consumerSecretsNoMatch"/>');
			return false;
		}
		
		return true;
	}

	function alertUser(message)
	{
		var stDiv = $("msg");
		var td = $("st_msg");
		td.innerHTML = message;
		stDiv.style.display = "";
		$('save').disabled = false;
	}
	
	var _showingRootServices = false;

	function toggleRootServices(e)
	{
		dojo.stopEvent(e);
		dojo.require('dojo.fx');

		var params = {
			node: $('root-services'),
			duration: 200
		}

		if (_showingRootServices)
		{
			dojo.fx.wipeOut(params).play();
		}
		else
		{
			dojo.fx.wipeIn(params).play();
		}

		_showingRootServices = !_showingRootServices;

	}

	dojo.addOnLoad(function() {
		dojo.query('#oauth-consumers-dialog input').onkeydown(function() {
			var message = $('msg');
			message.style.display = 'none';
		});

		dojo.connect($('action-form'), 'onsubmit', function(e) {
			dojo.stopEvent(e);
			performAction();
		});

		dojo.connect($('show-root-service'), 'onclick', toggleRootServices);
	
		<%@ include file="oslc_tabs_onload.jspf" %>		

	});
</script>

</body>
</html>
